#include <qapplication.h>

#include <iostream>

// A verbose object tells us what it is doing all the time
class VerboseObject : public QObject
{
public:
	VerboseObject( QObject *parent=0, char *name=0 ) : QObject( parent, name )
	{
		std::cout << "Created: " << QObject::name() << std::endl;
	}
	
	~VerboseObject()
	{
		std::cout << "Deleted: " << name() << std::endl;
	}
	
	void doStuff()
	{
		std::cout << "Do stuff: " << name() << std::endl;
	}
};

int main( int argc, char **argv )
{
	// Create an application
	QApplication a( argc, argv );
	
	// Create instances
	VerboseObject top( 0, "top" );
	VerboseObject *x = new VerboseObject( &top, "x" );
	VerboseObject *y = new VerboseObject( &top, "y" );
	VerboseObject *z = new VerboseObject( x, "z" );
	
	// Do stuff to stop the optimizer
	top.doStuff();
	x->doStuff();
	y->doStuff();
	z->doStuff();
	
	return 0;
}
