#ifndef PROPOBJECT_H
#define PROPOBJECT_H

#include <qobject.h>
#include <qvariant.h>

class PropObject : public QObject
{
	Q_OBJECT

	Q_PROPERTY( TestProperty testProperty READ testProperty WRITE setTestProperty )
	Q_ENUMS( TestProperty )

	Q_PROPERTY( QString anotherProperty READ anotherProperty )
	
public:
	PropObject( QObject *parent=0, char *name=0 );
	
	enum TestProperty { InitialValue, AnotherValue };
	
	void setTestProperty( TestProperty p );
	TestProperty testProperty() const;
	
	QString anotherProperty() const { return QString( "I'm read-only!" ); }

private:
	TestProperty m_testProperty;	
};

#endif
