#include "contact.h"

#include <qstringlist.h>

QTextStream &operator<<( QTextStream &s, const Contact &c )
{
    s << 3 << ":" 
	    << c.name.length() << ":" 
	    << c.eMail.length() << ":" 
	    << c.phone.length() << ":"
	    << "name:eMail:phone:"
	    << c.name 
	    << c.eMail 
	    << c.phone << '\n';
    
    return s;
}

QTextStream &operator>>( QTextStream &s, Contact &c )
{
    QString line = s.readLine();
    
    c.name = "";
    c.eMail = "";
    c.phone = "";
    
    int errors = 0;
    bool ok;
    
    int fieldCount;
    
    QStringList fields = QStringList::split( ":", line );
    
    fieldCount = fields[0].toInt( &ok );
    if( !ok )
	errors++;
    
    if( fields.count() != 2*fieldCount+2 )
	errors++;
    
    if( errors == 0 )
    {
	int valueOffset = 0;
	
	for( int currentField=0; currentField<fieldCount; currentField++ )
	{
	    int valueLength = fields[currentField+1].toInt( &ok );
	    
	    if( !ok )
	        errors++;
	    else
	    {
	        QString value = fields[fieldCount*2+1].mid( valueOffset, valueLength );
	        valueOffset+=valueLength;
		
	        if( fields[fieldCount+currentField+1] == "name" )
	            c.name = value;
	        else if( fields[fieldCount+currentField+1] == "eMail" )
	            c.eMail = value;
	        else if( fields[fieldCount+currentField+1] == "phone" )
	            c.phone = value;
	        else
	            errors++;
	    }
	}
    }
    
    return s;
}
