#include "listboxexample.h"

#include <qlabel.h>
#include <qhbox.h>
#include <qlistbox.h>
#include <qlineedit.h>
#include <qpushbutton.h>

ListBoxExample::ListBoxExample( QWidget *parent, char *name ) : QVBox( parent, name )
{
	m_listBox = new QListBox( this );
	
	QHBox *hb = new QHBox( this );
	m_lineEdit = new QLineEdit( hb );
	QPushButton *pbAdd = new QPushButton( "Add", hb );
	QPushButton *pbClear = new QPushButton( "Clear", hb );

	hb = new QHBox( this );
	new QLabel( "Selection: ", hb );
	m_label = new QLabel( "nothing", hb );
	
	connect( pbAdd, SIGNAL(clicked()), this, SLOT(addItem()) );
	connect( pbClear, SIGNAL(clicked()), m_listBox, SLOT(clear()) );
	connect( m_listBox, SIGNAL(selectionChanged()), this, SLOT(newSelection()) );
}

void ListBoxExample::addItem()
{
	m_listBox->insertItem( m_lineEdit->text() );
	m_lineEdit->setText( "" );
}

void ListBoxExample::newSelection()
{
	if( !m_listBox->selectedItem() )
		m_label->setText( "nothing" );
	else
		m_label->setText( m_listBox->selectedItem()->text() );
}