#include <qpainter.h>
#include <qcombobox.h>
#include <qpixmap.h>

#include "colortableitem.h"

ColorTableItem::ColorTableItem( QTable *table, const QString &color ) : QTableItem( table, EditType::WhenCurrent, color )
{
}
	
QWidget *ColorTableItem::createEditor() const
{
	QComboBox *cb = new QComboBox( table()->viewport() );
  QObject::connect( cb, SIGNAL( activated( int ) ), table(), SLOT( doValueChanged() ) );
  
  QPixmap pm( 100, 20 );
  
  pm.fill( Qt::white );
  cb->insertItem( pm );
  pm.fill( Qt::gray );
  cb->insertItem( pm );
  pm.fill( Qt::black );
  cb->insertItem( pm );
	pm.fill( Qt::red );
  cb->insertItem( pm );
  pm.fill( Qt::yellow );
  cb->insertItem( pm );
  pm.fill( Qt::green );
  cb->insertItem( pm );
  pm.fill( Qt::cyan );
  cb->insertItem( pm );
  pm.fill( Qt::blue );
  cb->insertItem( pm );
  pm.fill( Qt::magenta  );
  cb->insertItem( pm );

	if( text() == "White" )
		cb->setCurrentItem( 0 );
	else if( text() == "Gray" )
		cb->setCurrentItem( 1 );
	else if( text() == "Black" )
		cb->setCurrentItem( 2 );
	else if( text() == "Red" )
		cb->setCurrentItem( 3 );
	else if( text() == "Yellow" )
		cb->setCurrentItem( 4 );
	else if( text() == "Green" )
		cb->setCurrentItem( 5 );
	else if( text() == "Cyan" )
		cb->setCurrentItem( 6 );
	else if( text() == "Blue" )
		cb->setCurrentItem( 7 );
	else if( text() == "Magenta" )
		cb->setCurrentItem( 8 );
	
  return cb;
}

void ColorTableItem::setContentFromEditor( QWidget *w )
{
	if( w->inherits( "QComboBox" ) )
	{
		switch( ((QComboBox*)w)->currentItem() )
		{
			case 0:
    		setText( "White" );
    		break;
			case 1:
    		setText( "Gray" );
    		break;
			case 2:
    		setText( "Black" );
    		break;
			case 3:
    		setText( "Red" );
    		break;
			case 4:
    		setText( "Yellow" );
    		break;
			case 5:
    		setText( "Green" );
    		break;
			case 6:
    		setText( "Cyan" );
    		break;
			case 7:
    		setText( "Blue" );
    		break;
			case 8:
    		setText( "Magenta" );
    		break;
    }
  }
  else
    QTableItem::setContentFromEditor( w );
}
	
void ColorTableItem::paint( QPainter *p, const QColorGroup &cg, const QRect &cr, bool selected )
{
	if( text() == "White" )
		p->setBrush( Qt::white );
	else if( text() == "Gray" )
		p->setBrush( Qt::gray );
	else if( text() == "Black" )
		p->setBrush( Qt::black );
	else if( text() == "Red" )
		p->setBrush( Qt::red );
	else if( text() == "Yellow" )
		p->setBrush( Qt::yellow );
	else if( text() == "Green" )
		p->setBrush( Qt::green );
	else if( text() == "Cyan" )
		p->setBrush( Qt::cyan );
	else if( text() == "Blue" )
		p->setBrush( Qt::blue );
	else if( text() == "Magenta" )
		p->setBrush( Qt::magenta );

	p->drawRect( table()->cellRect(row(), col()) );
}